//********************************************************************************************************************************
//*                                                                                                                              *
//*     Image Recognition Library  3delite 2011-2021                                                                            *
//*     See Image Recognition Library ReadMe.txt for details                                                                     *
//*                                                                                                                              *
//* Licenses available for usage of this library:                                                                                *
//* Freeware License: 25                                                                                                        *
//*     http://www.shareit.com/product.html?productid=300983850                                                                  *
//* Shareware License: 50                                                                                                       *
//*     http://www.shareit.com/product.html?productid=300486940                                                                  *
//* Commercial License: 250                                                                                                     *
//*     http://www.shareit.com/product.html?productid=300486939                                                                  *
//*                                                                                                                              *
//*     https://www.3delite.hu/Object%20Pascal%20Developer%20Resources/ImageRecognitionLibrary.html                              *
//*                                                                                                                              *
//* If you have any questions or enquiries please mail: 3delite@3delite.hu                                                       *
//*                                                                                                                              *
//* Good coding! :)                                                                                                              *
//* 3delite                                                                                                                      *
//********************************************************************************************************************************

unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, UITypes,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, ImageRecognitionDefs, Vcl.ExtCtrls, Vcl.ComCtrls, JPEG;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Button2: TButton;
    Edit2: TEdit;
    Button3: TButton;
    Label2: TLabel;
    Memo1: TMemo;
    GroupBox2: TGroupBox;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Image2: TImage;
    ProgressBar1: TProgressBar;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label5: TLabel;
    Edit3: TEdit;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Edit4: TEdit;
    Label6: TLabel;
    TrackBar3: TTrackBar;
    Edit5: TEdit;
    Label7: TLabel;
    TrackBar4: TTrackBar;
    Edit6: TEdit;
    Label8: TLabel;
    Edit7: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    TrackBar8: TTrackBar;
    Edit10: TEdit;
    Label12: TLabel;
    TrackBar9: TTrackBar;
    Label13: TLabel;
    Label14: TLabel;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    Label15: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure TrackBar9Change(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);
    procedure Edit4Exit(Sender: TObject);
    procedure Edit5Exit(Sender: TObject);
    procedure Edit6Exit(Sender: TObject);
    procedure Edit7Exit(Sender: TObject);
    procedure Edit9Exit(Sender: TObject);
    procedure Edit8Exit(Sender: TObject);
    procedure Edit10Exit(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure TrackBar7Change(Sender: TObject);
    procedure TrackBar8Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
    STARTUP_MESSAGE = 'This tutorial demonstrates comparing two pictures which have different dimensions in "relative" mode. '
        + 'This means that the search for bitmap is compared with an allowed difference value. '
        + 'Setting a "DifferenceTolerance" value will allow a concrete pixel count to differ completely. '
        + 'To allow for the two pictures to differ in dimensions, we pre-process the pictures (resample to the same size). '
        + 'ARGB is much slower then exact mode and AHSL is the slowest.'
        ;

var
    Form1: TForm1;
    IRObjectSearchIn: TIRObject;
    IRObjectSearchFor: TIRObject;
    IRCreateObjectParameters: TIRCreateObjectParameters;

implementation

{$R *.dfm}

Uses
    FreeImageLoader;

function mSec2Time(mSec: Int64): String;
var
  tHours: String;
  tMinutes: String;
  tSecs: String;
  tmSecs: String;
  Seconds: Int64;
begin
    if mSec = 4294967295
        then mSec := 0;
    Seconds := mSec div 1000;
    tHours := IntToStr(Seconds div 3600);
    if Length(tHours) = 1
        then tHours := '0' + tHours;
    tMinutes := IntToStr(((Seconds - (StrToInt(tHours) * 3600)) div 60));
    if Length(tMinutes) = 1
        then tMinutes := '0' + tMinutes;
    tSecs := IntToStr(Seconds - (StrToInt(tHours) * 3600 + StrToInt(tMinutes) * 60));
    if Length(tSecs) = 1
        then tSecs := '0' + tSecs;
    tmSecs := IntToStr(mSec - ((StrToInt(tHours) * 3600 + StrToInt(tMinutes) * 60) + StrToInt(tSecs)) * 1000);
    case Length(tmSecs) of
        1: tmSecs := '00' + tmSecs;
        2: tmSecs := '0' + tmSecs;
    end;
    //tmSecs := Copy(tmSecs, 1, 2);
    Result := tHours + ':' + tMinutes + ':' + tSecs + '.' + tmSecs;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    if ImageRecognitionLibraryLoaded then begin
        Memo1.Lines.Add(ImageRecognitionLibraryName + ' loaded.');
        Memo1.Lines.Add(Caption + ' ready.');
    end else begin
        Memo1.Lines.Add('Error loading ' + ImageRecognitionLibraryName);
    end;
    TrackBar5Change(nil);
    TrackBar6Change(nil);
    TrackBar7Change(nil);
    TrackBar8Change(nil);
    TrackBar9Change(nil);
    MessageDlg(STARTUP_MESSAGE, mtInformation, [mbOk], 0);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    if OpenDialog1.Execute then begin
        Edit1.Text := OpenDialog1.FileName;
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    if OpenDialog1.Execute then begin
        Edit2.Text := OpenDialog1.FileName;
    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
    Error: Integer;
    Bitmap: TBitmap;
    PerfFreq, FreqCountStart, FreqCountEnd: Int64;
    ProcessingTime: Integer;
begin
    Bitmap := nil;
    //* Clear all
    ZeroMemory(@IRObjectSearchIn, SizeOf(TIRObject));
    //* Clear all
    ZeroMemory(@IRCreateObjectParameters, SizeOf(TIRCreateObjectParameters));
    //* Resize the pictures with the selected resampler
    IRCreateObjectParameters.ProcessType := IR_PROCESS_TYPE_RESAMPLE;
    IRCreateObjectParameters.Dimensions.Width := 100;
    IRCreateObjectParameters.Dimensions.Height := 100;
    //* Use the selected resampler
    IRCreateObjectParameters.Resampler := ComboBox1.ItemIndex;
    QueryPerformanceFrequency(PerfFreq);
    QueryPerformanceCounter(FreqCountStart);
    //* Create the object
    Error := ImageRecognition_CreateObject(PChar(Edit1.Text), IRObjectSearchIn, IRCreateObjectParameters);
    QueryPerformanceCounter(FreqCountEnd);
    ProcessingTime := Round((FreqCountEnd - FreqCountStart) / PerfFreq * 1000);
    if Error = IR_OK then begin
        Memo1.Lines.Add('Created object: $' + IntToHex(NativeInt(IRObjectSearchIn.ImageObject), 8) + ' ' + IntToStr(IRObjectSearchIn.OriginalDimensions.Width) + 'x' + IntToStr(IRObjectSearchIn.OriginalDimensions.Height));
        Memo1.Lines.Add('Loading time: ' + mSec2Time(ProcessingTime));
        //* Note that the loader automatically creates the TBitmap object
        FreeImageLoadImage(Edit1.Text, Bitmap, Handle);
        Image1.Picture.Assign(Bitmap);
        FreeAndNil(Bitmap);
    end else begin
        Memo1.Lines.Add('Error creating object, error code: ' + IntToStr(Error));
    end;
    //* Clear all
    ZeroMemory(@IRObjectSearchFor, SizeOf(TIRObject));
    //* Clear all
    ZeroMemory(@IRCreateObjectParameters, SizeOf(TIRCreateObjectParameters));
    //* Resize the pictures with the selected resampler
    IRCreateObjectParameters.ProcessType := IR_PROCESS_TYPE_RESAMPLE;
    IRCreateObjectParameters.Dimensions.Width := 100;
    IRCreateObjectParameters.Dimensions.Height := 100;
    //* Use the selected resampler
    IRCreateObjectParameters.Resampler := ComboBox1.ItemIndex;
    QueryPerformanceFrequency(PerfFreq);
    QueryPerformanceCounter(FreqCountStart);
    //* Create the object
    Error := ImageRecognition_CreateObject(PChar(Edit2.Text), IRObjectSearchFor, IRCreateObjectParameters);
    QueryPerformanceCounter(FreqCountEnd);
    ProcessingTime := Round((FreqCountEnd - FreqCountStart) / PerfFreq * 1000);
    if Error = IR_OK then begin
        Memo1.Lines.Add('Created object: $' + IntToHex(NativeInt(IRObjectSearchFor.ImageObject), 8) + ' ' + IntToStr(IRObjectSearchFor.OriginalDimensions.Width) + 'x' + IntToStr(IRObjectSearchFor.OriginalDimensions.Height));
        Memo1.Lines.Add('Loading time: ' + mSec2Time(ProcessingTime));
        //* Note that the loader automatically creates the TBitmap object
        FreeImageLoadImage(Edit2.Text, Bitmap, Handle);
        Image2.Picture.Assign(Bitmap);
        FreeAndNil(Bitmap);
    end else begin
        Memo1.Lines.Add('Error creating object, error code: ' + IntToStr(Error));
    end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
    Error: Integer;
begin
    //* Search in object
    Error := ImageRecognition_FreeObject(IRObjectSearchIn);
    if Error = IR_OK then begin
        Memo1.Lines.Add('Freed object: ' + IRObjectSearchIn.FileName);
        Image1.Picture.Assign(nil);
    end else begin
        Memo1.Lines.Add('Error freeing object, error code: ' + IntToStr(Error));
    end;
    //* Search for object
    Error := ImageRecognition_FreeObject(IRObjectSearchFor);
    if Error = IR_OK then begin
        Memo1.Lines.Add('Freed object: ' + IRObjectSearchFor.FileName);
        Image2.Picture.Assign(nil);
    end else begin
        Memo1.Lines.Add('Error freeing object, error code: ' + IntToStr(Error));
    end;
end;

function StatusCallback(Progress: Double; StatusType: Integer; User: Pointer): Integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
begin
    Form1.ProgressBar1.Position := Round(Progress);
    //* Return IR_ABORT_PROCESSING to abort the processing
    Result := IR_CONTINUE_PROCESSING;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
    Parameters: TIRProcessParameters;
    Results: TIRResult;
    Error: Integer;
    PerfFreq, FreqCountStart, FreqCountEnd: Int64;
    ProcessingTime: Integer;
    PMatch: PIRResultMatches;
    i: Integer;
begin
    ProgressBar1.Position := 0;

    //* Clear all
    ZeroMemory(@Parameters, SizeOf(TIRProcessParameters));

    //* Relative ARGB mode
    if RadioButton1.Checked then begin
        Parameters.CompareType := IR_COMPARE_TYPE_RELATIVE_ARGB;
        Parameters.ARGBATolerance := StrToInt(Edit3.Text);
        Parameters.ARGBRTolerance := StrToInt(Edit4.Text);
        Parameters.ARGBGTolerance := StrToInt(Edit5.Text);
        Parameters.ARGBBTolerance := StrToInt(Edit6.Text);
    end;
    //* Relative AHSL mode
    if RadioButton2.Checked then begin
        Parameters.CompareType := IR_COMPARE_TYPE_RELATIVE_AHSL;
        //* AHSL component values range from 0 to 1
        Parameters.AHSLATolerance := StrToFloat(Edit7.Text);
        Parameters.AHSLHTolerance := StrToFloat(Edit9.Text);
        Parameters.AHSLSTolerance := StrToFloat(Edit8.Text);
        Parameters.AHSLLTolerance := StrToFloat(Edit10.Text);
    end;

    //* Allow multiple matches
    Parameters.MultipleMatchesMax := 255;

    //* Filter out matches that are duplicates - their X-Y position difference is less than 10 pixels
    Parameters.MultipleMatchesFilterTresholdX := 10;
    Parameters.MultipleMatchesFilterTresholdY := 10;

    //* Number of pixels that may differ completely
    Parameters.DifferenceTolerance := Trunc(IRObjectSearchFor.OriginalDimensions.Width * IRObjectSearchFor.OriginalDimensions.Height * (TrackBar9.Position / 100));

    //* Multi-threaded processing
    if CheckBox1.Checked then begin
        Parameters.MultiThreadedProcessing := True;
    end else begin
        Parameters.MultiThreadedProcessing := False;
    end;

    //* A callback to get notified about the progress
    //* Note that this can significantly reduce performance
    Parameters.StatusCallback := StatusCallback;

    QueryPerformanceFrequency(PerfFreq);
    QueryPerformanceCounter(FreqCountStart);

    //* Perform the search
    Error := ImageRecognition_Compare(IRObjectSearchIn, IRObjectSearchFor, Parameters, Results, nil);

    QueryPerformanceCounter(FreqCountEnd);
    ProcessingTime := Round((FreqCountEnd - FreqCountStart) / PerfFreq * 1000);

    if Error = IR_OK then begin
        //* The processing completed normally
    end else begin
        Memo1.Lines.Add('Error while processing, error code: ' + IntToStr(Error));
    end;
    if Results.Success then begin
        Memo1.Lines.Add('Successful search, match count: ' + IntToStr(Results.MatchCount));
        //* Create a rectangle sorrounding the matching part of the picture
        Image1.Canvas.Pen.Color := clRed;
        Image1.Canvas.Pen.Width := 5;
        Image1.Canvas.Brush.Style := bsSolid;
        Image1.Canvas.Brush.Color := clRed;
        //* Point to the first match
        PMatch := Results.Matches;
        //* Iterate over the matches
        for i := 0 to Results.MatchCount - 1 do begin
            Memo1.Lines.Add('Found at position: '
                + IntToStr(PMatch.Position.X)
                + 'x'
                + IntToStr(PMatch.Position.Y)
                + ' difference: '
                + IntToStr(PMatch.Difference));
            Image1.Canvas.MoveTo(PMatch.Position.X, PMatch.Position.Y);
            Image1.Canvas.LineTo(PMatch.Position.X + Image1.Picture.Width, PMatch.Position.Y);
            Image1.Canvas.LineTo(PMatch.Position.X + Image1.Picture.Width, PMatch.Position.Y + Image1.Picture.Height);
            Image1.Canvas.LineTo(PMatch.Position.X, PMatch.Position.Y + Image1.Picture.Height);
            Image1.Canvas.LineTo(PMatch.Position.X, PMatch.Position.Y);
            //* Point to the next match
            Inc(PMatch);
        end;
        Memo1.Lines.Add('Processing time: ' + mSec2Time(ProcessingTime));
        Image1.Update;
        Image1.Invalidate;
        //* After finished with the result object free the allocated memory
        ImageRecognition_FreeResult(Results);
    end else begin
        Memo1.Lines.Add('No match found.');
    end;
end;

procedure TForm1.Edit3Exit(Sender: TObject);
begin
    TrackBar1.Position := StrToInt(Edit3.Text);
end;

procedure TForm1.Edit4Exit(Sender: TObject);
begin
    TrackBar2.Position := StrToInt(Edit4.Text);
end;

procedure TForm1.Edit5Exit(Sender: TObject);
begin
    TrackBar3.Position := StrToInt(Edit5.Text);
end;

procedure TForm1.Edit6Exit(Sender: TObject);
begin
    TrackBar4.Position := StrToInt(Edit6.Text);
end;

procedure TForm1.Edit7Exit(Sender: TObject);
begin
    TrackBar5.Position := Trunc(StrToFloat(Edit7.Text) * 100);
end;

procedure TForm1.Edit8Exit(Sender: TObject);
begin
    TrackBar7.Position := Trunc(StrToFloat(Edit8.Text) * 100);
end;

procedure TForm1.Edit9Exit(Sender: TObject);
begin
    TrackBar6.Position := Trunc(StrToFloat(Edit9.Text) * 100);
end;

procedure TForm1.Edit10Exit(Sender: TObject);
begin
    TrackBar8.Position := Trunc(StrToFloat(Edit10.Text) * 100);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
    Edit3.Text := IntToStr(TrackBar1.Position);
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
    Edit4.Text := IntToStr(TrackBar2.Position);
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
    Edit5.Text := IntToStr(TrackBar3.Position);
end;

procedure TForm1.TrackBar4Change(Sender: TObject);
begin
    Edit6.Text := IntToStr(TrackBar4.Position);
end;

procedure TForm1.TrackBar5Change(Sender: TObject);
begin
    Edit7.Text := FloatToStr(TrackBar5.Position / 100);
end;

procedure TForm1.TrackBar6Change(Sender: TObject);
begin
    Edit9.Text := FloatToStr(TrackBar6.Position / 100);
end;

procedure TForm1.TrackBar7Change(Sender: TObject);
begin
    Edit8.Text := FloatToStr(TrackBar7.Position / 100);
end;

procedure TForm1.TrackBar8Change(Sender: TObject);
begin
    Edit10.Text := FloatToStr(TrackBar8.Position / 100);
end;

procedure TForm1.TrackBar9Change(Sender: TObject);
begin
    Label14.Caption := IntToStr(TrackBar9.Position) + ' %';
end;

end.
